// Original files from "howardpc" http://forum.lazarus.freepascal.org/index.php/topic,31169.msg199356.html#msg199356
// Slightly changed for use of Popup Menu in DBGrid

unit MainAddIndex;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, dbf, Forms, Controls, Graphics, Dialogs,
  DBGrids, DbCtrls, StdCtrls, Menus, LazFileUtils;

const
  CountriesFilename = 'countries.dbf';

type

  { TForm1 }

  TForm1 = class(TForm)
    BSortByCountry: TButton;
    BSortByCapital: TButton;
    BSortByID: TButton;
    Button1: TButton;
    dbfSource: TDataSource;
    grid: TDBGrid;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    Navigator: TDBNavigator;
    PopupMenu1: TPopupMenu;
    procedure BSortByCapitalClick(Sender: TObject);
    procedure BSortByCountryClick(Sender: TObject);
    procedure BSortByIDClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MenuItem1Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
  private
    CountriesDbf: TDbf;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  CountriesDbf:=TDbf.Create(Self);
  CountriesDbf.TableName:=CountriesFilename;
  if not FileExistsUTF8(CountriesFilename) then with CountriesDbf do begin
    TableLevel:=7;
    Exclusive:=True;
    FieldDefs.Add('ID', ftAutoInc, 0, True);
    FieldDefs.Add('CountryName', ftString, 25, True);
    FieldDefs.Add('Capital', ftString, 25, True);
    CreateTable;

    Open;
    Append;
    //Fields[0].AsInteger:=100;
    fields[1].AsString:='France';
    Fields[2].AsString:='Paris';
    Post;
    Append;
    //Fields[0].AsInteger:=101;
    fields[1].AsString:='Egypt';
    Fields[2].AsString:='Cairo';
    Post;
    Append;
    //Fields[0].AsInteger:=102;
    fields[1].AsString:='Indonesia';
    Fields[2].AsString:='Jakarta';
    Post;
    Append;
    //Fields[0].AsInteger:=103;
    fields[1].AsString:='Austria';
    Fields[2].AsString:='Vienna';
    Post;
    Append;
    //Fields[0].AsInteger:=104;
    fields[1].AsString:='Germany';
    Fields[2].AsString:='Berlin';
    Post;
    Append;
    //Fields[0].AsInteger:=105;
    fields[1].AsString:='USA';
    Fields[2].AsString:='Washington DC';
    Post;
    Append;
    //Fields[0].AsInteger:=106;
    fields[1].AsString:='Denmark';
    Fields[2].AsString:='Copenhagen';
    Post;
    Append;
    //Fields[0].AsInteger:=107;
    fields[1].AsString:='Netherland';
    Fields[2].AsString:='Amsterdam/The Hague';
    Post;
    Append;
    //Fields[0].AsInteger:=109;
    fields[1].AsString:='Portugal';
    Fields[2].AsString:='Lisbon';
    Post;
    Append;
    //Fields[0].AsInteger:=110;
    fields[1].AsString:='Spain';
    Fields[2].AsString:='Madrid';
    Post;
    Append;
    //Fields[0].AsInteger:=111;
    fields[1].AsString:='Romania';
    Fields[2].AsString:='Bucharest';
    Post;
    Append;
    //Fields[0].AsInteger:=112;
    fields[1].AsString:='San Marino';
    Fields[2].AsString:='San Marino';
    Post;
    Append;
    //Fields[0].AsInteger:=113;
    fields[1].AsString:='Luxembourg';
    Fields[2].AsString:='Luxembourg';
    Post;
    Append;
    //Fields[0].AsInteger:=114;
    fields[1].AsString:='Russia';
    Fields[2].AsString:='Moscow';
    Post;
    Append;
    //Fields[0].AsInteger:=115;
    fields[1].AsString:='Albania';
    Fields[2].AsString:='Tirana';
    Post;
    Append;
    //Fields[0].AsInteger:=116;
    fields[1].AsString:='Switzerland';
    Fields[2].AsString:='Bern';
    Post;
    Append;
    //Fields[0].AsInteger:=117;
    fields[1].AsString:='Greece';
    Fields[2].AsString:='Athens';
    Post;

    //AddIndex('idxByID', 'ID', [ixPrimary,ixUnique]);
    AddIndex('idxByCountry', 'CountryName', [ixCaseInsensitive]);
    AddIndex('idxByCapital', 'Capital', [ixCaseInsensitive]);
  end;
  CountriesDbf.Open;
  dbfSource.DataSet:=CountriesDbf;
  grid.DataSource:=dbfSource;
  Navigator.DataSource:=dbfSource;

  //change for DBGrid Popup Menu
  if (dbfSource.Dataset.FindField('ID') <> nil) then
    grid.PopupMenu := PopupMenu1
  else
    grid.PopupMenu := nil;

end;

procedure TForm1.BSortByCapitalClick(Sender: TObject);
begin
  CountriesDbf.IndexName:='idxByCapital';
end;

procedure TForm1.BSortByCountryClick(Sender: TObject);
begin
  CountriesDbf.IndexName:='idxByCountry';
end;

procedure TForm1.BSortByIDClick(Sender: TObject);
begin
  CountriesDbf.IndexName:='idxByID';
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if CountriesDbf.Filter = 'Capital=' + QuotedStr('nothing') then
    CountriesDbf.Filter := ''
  else
    CountriesDbf.Filter := 'Capital=' + QuotedStr('nothing');
  CountriesDbf.Filtered := true;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  with CountriesDbf do begin
    CloseIndexFile('idxByCapital');
    CloseIndexFile('idxByCountry');
    CloseIndexFile('idxByID');
  end;
  CountriesDbf.Close;
end;

//change for DBGrid Popup Menu - delete ID
procedure TForm1.MenuItem1Click(Sender: TObject);
begin
  if (not(dbfSource.Dataset.FieldByName('ID').IsNull)) then
    ShowMessage('Here you can delete Id ' + dbfSource.Dataset.FieldByName('ID').AsString + '.');
end;

//change for DBGrid Popup Menu - Edit ID
procedure TForm1.MenuItem2Click(Sender: TObject);
begin
  if (not(dbfSource.Dataset.FieldByName('ID').IsNull)) then
    ShowMessage('Here you can edit Id ' + dbfSource.Dataset.FieldByName('ID').AsString + '.');
end;

end.

begin
  Source := ExtractFilePath(Application.Name);
  MyDbf := TDbf.Create(nil);
  if not DirectoryExists(Source + 'data') then
     if not CreateDir(Source + 'data') then
        raise Exception.Create('Impossible de créer le répertoire');
  try
    { use relative path to "data" directory }
    MyDbf.FilePath := 'data';
    { we want to use Visual dBase VII compatible tables }
    MyDbf.TableLevel := 7;
    MyDbf.Exclusive := True;
    MyDbf.TableName := 'customers.dbf';
    With MyDbf.FieldDefs do begin
      Add('Id', ftAutoInc, 0, True);
      Add('Name', ftString, 80, True);
    End;
    MyDbf.CreateTable;
    MyDbf.Open;
    MyDbf.AddIndex('custid', 'Id', [ixPrimary, ixUnique]);
    { add a secondary index }
    MyDbf.AddIndex('custname','Name', [ixCaseInsensitive]);
finally
    MyDbf.Free;
  end;
